 <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
  <meta http-equiv="content-type" content="text/html; charset=windows-1250">
  <meta name="generator" content="PSPad editor, www.pspad.com">
  <title>Lezione 3 corso base PHP</title>
  </head>
  <body>
<h1> Lezione 4 corso PHP.
<h2> Form  GET e POST
  </h1>
  I form in generale utilizzado due variabili PHP (speciali) GET e POST che identificano i due metodi con cui  possibile gestire
  questo tipo di input. GET e POST sono definite variabili Super Globali perch sono accessibili da qulasiasi script in qualsiasi 
  momento senza che siano precedentemente dichiarate.
  <br>
Una form (modulo) HTML  costituita da un certo numero di elementi quali caselle di testo, men a discesa, caselle di spunta e cos via. Tali elementi consentono al visitatore della pagina di inserire delle informazioni esattamente come nel caso della compilazione di un questionario cartaceo.
Un buon manuale HTML pu aiutare molto per la comprensione di questa lezione e degli esempi che verranno proposti;  necessario, infatti, un minimo di dimestichezza con i tag utilizzati per la creazione di form.
Come funziona una form? Una volta inseriti i dati richiesti questi vengono inviati, tipicamente con la pressione di un apposito tasto (submit), ad uno script o ad un'applicazione CGI che li elabora. La URL dell'applicazione viene specificata con l'attributo action del tag form.
L'attributo method, invece, specifica il metodo da utilizzare per l'invio delle informazioni e pu essere GET o POST. Con il metodo GET le informazioni vengono incluse nell'indirizzo URL; sono pertanto visibili nella barra degli indirizzi del browser ma, soprattutto, sono vincolate dalla lunghezza massima di una URL (256 caratteri).
Con il metodo POST, invece, i dati della form vengono scritti sullo "standard input" dell'applicazione destinataria e non sono visibili nella barra degli indirizzi del browser; inoltre, non ci sono limiti sulla quantit di dati inviata.
Dal punto di vista del programmatore PHP i due metodi sono di fatto equivalenti: l'interprete PHP, infatti, analizza sia le informazioni passate tramite la URL (metodo GET) che quelle ricevute sullo standard input (metodo POST) e le rende immediatamente disponibili nello script di destinazione sotto forma di variabili globali.
In alternativa, si pu accedere alle informazioni inviate con i metodi GET e POST utilizzando gli array associativi $HTTP_GET_VARS e $HTTP_POST_VARS, rispettivamente. Ad esempio, se tramite il metodo GET inviamo ad uno script PHP un parametro di nome "pagina" e di valore pari a 1, all'interno dello script stesso potremo accedere a tale informazione sia usando la variabile globale $p, sia accedendo a $HTTP_GET_VARS["p"], cio all'elemento dell'array associativo $HTTP_GET_VARS individuato dalla chiave "p".

  <br>
  <br>
  <b>Esempio 1 </b>
  <br>
  <br>

  <form method="POST" action="">
  
  Nome:    <input type="text" name="nome">
  Cognome: <input type="text" name="cognome">
  <input type= "submit" value="Invia">
  
  </form>
  
  <?php
 
 $nome = $_POST["nome"];
 $cognome = $_POST["cognome"];
  
  echo 'Ciao' . '  '. $nome . '  ' . $cognome . '.' .  ' '. 'Come stai?';
  
  //se lasciamo il codice cos alla primo caricamento della pagina l'interprete PHP genera una notifica
  //la quale indica che non sono stati inseriti elementi da passare a POST. Per risolvere questo problema
  //si fa come l'esempio sotto....
  
  ?>
  
  <br>
  <br>
  <b>Esempio 2 </b>
  <br>
  <br>
  
   <?php
 
 if (isset($_POST["nome"])) {
 
 
 $nome = $_POST["nome"];
 $cognome = $_POST["cognome"];
  
 echo 'Ciao' . '  '. $nome . '  ' . $cognome . '.' .  ' '. 'Come stai?';
 
 }
 // se sostituisco $_GET al posto di $_POST i dati inseriti nella form verranno visualizzati nella barra degli indirizzi (URL).
 
   ?>
   
    <br>
  <br>
  <b>Esempio 3 </b>
  <br>
  <br>
  
   <?php
   
   
   
   ?>
   
   
  </body>
  </html>
  